package com.alihealth.d2d.provtest.service.handle.business;

import com.alihealth.d2d.provtest.domain.DrugUsingUnitBaseInfo;
import com.alihealth.d2d.provtest.entity.EventBody;
import com.alihealth.d2d.provtest.entity.InstanceDetail;
import com.alihealth.d2d.provtest.entity.ItemDetail;
import com.alihealth.d2d.provtest.entity.VTTSBasic;
import com.alihealth.d2d.provtest.service.IDrugUsingUnitBaseInfoService;
import com.alihealth.d2d.provtest.service.XmlParserService;
import com.alihealth.d2d.provtest.service.handle.AbstractEventDataHandler;
import com.alihealth.d2d.provtest.service.handle.EventSubType;
import com.baomidou.mybatisplus.extension.service.IService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author Jason 药品使用单位基本信息数据子集
 * @date 2025年06月05日 11:14:43
 */
@Service
@EventSubType("1017")
public class SubType1017Handler extends AbstractEventDataHandler<DrugUsingUnitBaseInfo> {
    protected final Logger log = LoggerFactory.getLogger(getClass());

    @Autowired
    private IDrugUsingUnitBaseInfoService service;

    @Autowired
    private XmlParserService xmlParserService;

    @Override
    protected Class<DrugUsingUnitBaseInfo> getEntityClass() {
        return DrugUsingUnitBaseInfo.class;
    }

    @Override
    protected IService<DrugUsingUnitBaseInfo> getService() {
        return service;
    }

    @Override
    protected DrugUsingUnitBaseInfo convertToEntity(EventBody eventBody, ItemDetail item, InstanceDetail instance) {
        return null;
    }

    @Override
    public String getSubType() {
        return "1017";
    }

    @Override
    public void handleBase(String xml,String eventId) {
        VTTSBasic<DrugUsingUnitBaseInfo> result = xmlParserService.parseDataXml(
                    xml,
                DrugUsingUnitBaseInfo.class
            );
        List<DrugUsingUnitBaseInfo> list = result.getDataset();
        if(list!=null && !list.isEmpty()){
            list.stream()
                    .forEach(item -> {
                        item.setEventId(eventId);
                    });
            getService().saveBatch(list);
            log.info("数据类型："+getSubType()+"，入库的数据条数:{}", list.size());
        }
    }
}
